﻿init -10 python:
    import math
    def name_callback(event, interact=True, name=None, **kwargs):
        global speaking_char
        if event == "begin":
            speaking_char = name
    class SpriteFocus(object):
        def __init__(self, char_name):
            self.char_name = char_name
        def __call__(self, trans, start_time, anim_time):
            def get_ease(t):
                return .5 - math.cos(math.pi * t) / 2.0
            global sprite_focus, speaking_char
            char_name = self.char_name
            if char_name not in sprite_focus:
                sprite_focus[char_name] = False
            anim_length = 0.2
            bright_change = 0.08
            sat_change = 0.2
            zoom_change = 0.0025
            y_change = 3
            is_talking = speaking_char == char_name
            if isinstance(sprite_focus[char_name], (int, float)) and anim_time < sprite_focus[char_name]:
                sprite_focus[char_name] = is_talking
            if sprite_focus[char_name] != is_talking and isinstance(sprite_focus[char_name], bool):
                sprite_focus[char_name] = anim_time
                if renpy.is_skipping() or renpy.in_rollback():
                    sprite_focus[char_name] = is_talking
            curr_time = max(anim_time - sprite_focus[char_name],0)
            curr_ease = 1.0
            if curr_time < anim_length and not isinstance(sprite_focus[char_name], bool):
                curr_ease = get_ease(curr_time/anim_length)
            else:
                sprite_focus[char_name] = is_talking
            if is_talking:
                trans.matrixcolor = SaturationMatrix((1.0-sat_change) + curr_ease * sat_change) * BrightnessMatrix(-bright_change + curr_ease * bright_change)
                trans.zoom = min(curr_ease * zoom_change + (1.0-zoom_change), 1.0)
                trans.yoffset = y_change - curr_ease * y_change
            else:
                trans.matrixcolor = SaturationMatrix(1.0 - curr_ease * sat_change) * BrightnessMatrix(curr_ease * -bright_change)
                trans.zoom = max(1.0 - curr_ease * zoom_change, (1.0-zoom_change))
                trans.yoffset = y_change * curr_ease
            return 0

init -1 python:
    def sprite_mapper(input_image_list):
        for image_path in input_image_list:
            image_name = image_path.split('/')[-1].split('.')[0]
            image_id = image_name.split("_")[0]
            renpy.image(image_name.replace("_", " ", 1), At(image_name, sprite_highlight(image_id)))
    files = renpy.list_files()
    image_list = [s for s in files if "images/sprites" in s]
    sprite_mapper(image_list)

init python:
    class char:
        def __init__(self, name, unknown = "Unknown"):
            self.id = str(name).lower().strip()
            self.n = Character(name.strip(), callback = name_callback, cb_name = self.id, image = self.id)
            self.u = Character(unknown.strip(), callback = name_callback, cb_name = self.id, image = self.id)
            self.t = Character(name.strip() + "'s Thoughts", callback = name_callback, cb_name = self.id, image = self.id, what_prefix = "* {i}", what_suffix = "{/i} *")
        def set(self):
            global char_dict
            global char_enabled
            if char_enabled == False:
                char_enabled = True
            char_dict[self.id] = {}
            char_dict[self.id]['unlocked'] = True
            char_dict[self.id]['orientation'] = False
            char_dict[self.id]['nude'] = []
            char_dict[self.id]['stage_selected'] = 0
            char_dict[self.id]['stages'] = [0]
            char_dict_keys = list(char_dict.keys())
            char_dict_keys.sort()
            char_dict_temp = {i: char_dict[i] for i in char_dict_keys}
            char_dict = char_dict_temp
            renpy.notify(str(self.n) + "'s character page unlocked!")
        def add_stage(self, stage, nude = False):
            global char_dict
            if nude:
                nude_str = "nude "
                char_dict[self.id]['nude'].append(stage)
            else:
                nude_str = ""
                char_dict[self.id]['stages'].append(stage)
            if stage == -1:
                renpy.notify(str(self.n) + "'s pre-story " + nude_str + "stage added!")
            else:
                renpy.notify(str(self.n) + "'s " + nude_str + "stage " + str(stage) + " added!")
        def orient(self):
            global char_dict
            char_dict[self.id]['orientation'] = True
            renpy.notify(str(self.n) + "'s sexual orientation discovered!")
    keymap_new = renpy.Keymap(
        rollback = renpy.rollback,
        screenshot = _screenshot,
        toggle_fullscreen = renpy.toggle_fullscreen,
        toggle_afm = _keymap_toggle_afm,
        toggle_skip = _keymap_toggle_skipping,
        fast_skip = _fast_skip,
        game_menu = _invoke_game_menu,
        hide_windows = renpy.curried_call_in_new_context("hide_interface"),
        launch_editor = _launch_editor,
        reload_game = _reload_game,
        developer = _developer,
        quit = renpy.quit_event,
        iconify = renpy.iconify,
        help = _help,
        choose_renderer = renpy.curried_call_in_new_context("_choose_renderer"),
        console = _console.enter,
        profile_once = _profile_once,
        memory_profile = _memory_profile,
        self_voicing = Preference("self voicing", "toggle"),
        clipboard_voicing = Preference("clipboard voicing", "toggle"),
        debug_voicing = Preference("debug voicing", "toggle"),
        progress_screen = _progress_screen,
        )
    config.underlay = [ keymap_new ]

init -2:
    transform sprite_highlight(sprite_name):
        function SpriteFocus(sprite_name)

init:
    define about_description = "This game is a remake of Curvy Town by {a=https://boosty.to/hvostt}Hvostt{/a}. If you like the content be sure to check out our shared {a=https://discord.com/invite/t2zZC5FaH5}Discord{/a}.\n\nCredits:\n-"
    define flash = Fade(.05, 0.0, .45, color="#fff")
    define flash_pink = Fade(.05, 0.0, .45, color="#e5008c")
    default char_dict = {}
    default char_enabled = False
    default char_selected = ""
    default char_selected_nude = "display"
    $ config.top_layers.append("quick_menu")
    # FETISHES
    default fetish_cheating = True
    default fetish_cuckolding = True
    default fetish_cougar = True
    default fetish_futanari = True
    default fetish_grotesque = True
    default fetish_hairy = True
    default fetish_humiliation = True
    default fetish_lesbian = True
    default fetish_pregnancy = True
    default fetish_urination = True
    # SCREENS
    screen fetish_settings():
        modal True
        add "black" alpha 0.5
        add "gui/fetish_settings.png" xalign 0.5 yalign 0.375
        text "{font=gui/fonts/bimbo_jve.ttf}Fetish Settings{/font}" size 85 xalign 0.5 yalign 0.12
        vbox:
            style_prefix "check"
            xalign 0.0
            xpos 280
            yalign 0.0
            ypos 230
            spacing 24
            xsize 1360
            text "   Optional fetishes provide extra side stories and scenes to the game. Disabling a fetish blocks related content in the game - there are no alternative routes or plot developments to replace it. For the complete experience keep them all enabled.\n   When a fetish is enabled, it doesn't mean all characters are going to engage in it, only that it will eventually appear in some shape or form." size 32
        hbox:
            vbox:
                style_prefix "check"
                xpos 280
                ypos 438
                spacing 24
                xmaximum 420
                label _("Optional Fetishes")
                textbutton _("Cheating") action ToggleVariable("fetish_cheating")
                if fetish_cheating == False:
                    textbutton _("Cuckolding") action None xpos 40
                else:
                    textbutton _("Cuckolding") action ToggleVariable("fetish_cuckolding") xpos 40
                textbutton _("Grotesque Modifications") action ToggleVariable("fetish_grotesque")
                if fetish_grotesque == False:
                    textbutton _("Futanari") action None xpos 40
                else:
                    textbutton _("Futanari") action ToggleVariable("fetish_futanari") xpos 40
            vbox:
                style_prefix "check"
                xpos 510
                ypos 438
                spacing 24
                label _("")
                textbutton _("Hair, Pubic & Armpit") action ToggleVariable("fetish_hairy")
                textbutton _("Humiliation") action ToggleVariable("fetish_humiliation")
                textbutton _("Sex, Cougar") action ToggleVariable("fetish_cougar")
                textbutton _("Sex, Lesbian") action ToggleVariable("fetish_lesbian")
            vbox:
                style_prefix "check"
                xpos 740
                ypos 438
                spacing 24
                label _("")
                textbutton _("Sex, Pregnant") action ToggleVariable("fetish_pregnancy")
                textbutton _("Urination") action ToggleVariable("fetish_urination")
        vbox:
            xalign 0.5
            ypos 860
            spacing 24
            textbutton _("Apply"):
                xalign 0.5
                style "return_button"
                action [ With( Dissolve(.5) ), Return(False) ]
    screen characters():
        default tt = Tooltip("")
        tag menu
        use game_menu(_("Characters"), scroll="viewport"):
            vbox:
                style_prefix "char"
                for char in char_dict:
                    hbox:
                        if char_dict[char]['unlocked'] and char_selected != char:
                            textbutton _(char_data[char]['id']) action [SetVariable("char_selected", char), SelectedIf(char_selected == char)]
                        else:
                            textbutton _(char_data[char]['id']) action [SetVariable("char_selected", ""), SelectedIf(char_selected == char)]
                    pass
        image "gui/characters/measure.png" xpos 1430 ypos -25
        if tt.value:
            frame:
                style "frameTooltip"
                xpos 465
                ypos 190
                xminimum 520
                xmaximum 520
                yminimum 800
                ymaximum 800
                padding (20, 20)
                hbox xalign 0.0 yalign 0.0:
                    text tt.value xalign 0.0 yalign 0.0
        if char_selected != "":
            if char_dict[char_selected]['orientation']:
                $ orientation = " {color=#888888}Orientation:{/color} [char_data[char_selected]['orientation']]"
            else:
                $ orientation = ""
            if "bwh" in char_data[char_selected]:
                $ bwh = "\n\n{color=#888888}Bust:{/color} [char_data[char_selected]['bwh'][char_dict[char_selected]['stage_selected']][0]]\n{color=#888888}Waist:{/color} [char_data[char_selected]['bwh'][char_dict[char_selected]['stage_selected']][1]]\n{color=#888888}Hips:{/color} [char_data[char_selected]['bwh'][char_dict[char_selected]['stage_selected']][2]]"
            else:
                $ bwh = ""
            $ char_desc = "{color=#888888}Name:{/color} [char_data[char_selected]['id']]\n\n{color=#888888}Age:{/color} [char_data[char_selected]['age'][char_dict[char_selected]['stage_selected']]]" + orientation + "\n\n{color=#888888}Height:{/color} [char_data[char_selected]['size'][char_dict[char_selected]['stage_selected']][0]] {color=#888888}Weight:{/color} [char_data[char_selected]['size'][char_dict[char_selected]['stage_selected']][1]]" + bwh + "\n\n{color=#888888}Likes:{/color} [char_data[char_selected]['likes'][char_dict[char_selected]['stage_selected']]]\n\n[char_data[char_selected]['description'][char_dict[char_selected]['stage_selected']]]"
            if char_dict[char_selected]['stage_selected'] in char_dict[char_selected]['nude']:
                imagebutton idle "[sprite_rootdir]/[char_selected]/[char_data[char_selected][char_selected_nude][char_dict[char_selected]['stage_selected']]].png" xcenter 0.72 ypos -25 hovered tt.Action(char_desc) action NullAction() focus_mask True
            else:
                imagebutton idle "[sprite_rootdir]/[char_selected]/[char_data[char_selected]['display'][char_dict[char_selected]['stage_selected']]].png" xcenter 0.72 ypos -25 hovered tt.Action(char_desc) action NullAction() focus_mask True
            image "gui/characters/overlay.png" xcenter 0.72 ypos -25
            if char_dict[char_selected]['stage_selected'] in char_dict[char_selected]['nude'] and char_selected_nude == "display_nude":
                imagebutton auto "gui/characters/nude_%s.png" xpos 1700 ypos 40 action SetVariable("char_selected_nude", "display") focus_mask True
            elif char_dict[char_selected]['stage_selected'] in char_dict[char_selected]['nude']:
                imagebutton auto "gui/characters/dressed_%s.png" xpos 1700 ypos 40 action SetVariable("char_selected_nude", "display_nude") focus_mask True
            if -1 in char_dict[char_selected]['stages']:
                textbutton _("P") xcenter 0.95 ypos 990 action [SetDict(char_dict[char_selected], "stage_selected", -1), SelectedIf(char_dict[char_selected]['stage_selected'] == -1)]
            if 0 in char_dict[char_selected]['stages']:
                textbutton _("0") xcenter 0.95 ypos 930 action [SetDict(char_dict[char_selected], "stage_selected", 0), SelectedIf(char_dict[char_selected]['stage_selected'] == 0)]
            if 1 in char_dict[char_selected]['stages']:
                textbutton _("1") xcenter 0.95 ypos 870 action [SetDict(char_dict[char_selected], "stage_selected", 1), SelectedIf(char_dict[char_selected]['stage_selected'] == 1)]
            if 2 in char_dict[char_selected]['stages']:
                textbutton _("2") xcenter 0.95 ypos 810 action [SetDict(char_dict[char_selected], "stage_selected", 2), SelectedIf(char_dict[char_selected]['stage_selected'] == 2)]
            if 3 in char_dict[char_selected]['stages']:
                textbutton _("3") xcenter 0.95 ypos 750 action [SetDict(char_dict[char_selected], "stage_selected", 3), SelectedIf(char_dict[char_selected]['stage_selected'] == 3)]
            if 4 in char_dict[char_selected]['stages']:
                textbutton _("4") xcenter 0.95 ypos 690 action [SetDict(char_dict[char_selected], "stage_selected", 4), SelectedIf(char_dict[char_selected]['stage_selected'] == 4)]
            if 5 in char_dict[char_selected]['stages']:
                textbutton _("5") xcenter 0.95 ypos 630 action [SetDict(char_dict[char_selected], "stage_selected", 5), SelectedIf(char_dict[char_selected]['stage_selected'] == 5)]

# GENERAL SETTINGS
define config.version = "0.0.1"
define sprite_focus = {}
define sprite_rootdir = "images/sprites/"
default speaking_char = None
default fetishes_chosen = False
default storypoint = "Disclaimer"

# CHARACTERS
define nar = Character(None, callback = name_callback, cb_name = None, image = None)
define ang = char("Angela", "Girl")
define cla = char("Claire", "Girl's Voice")
define emm = char("Emma", "High School Student")
define iri = char("Iris", "Mom")
define jac = char("Jack")
define kyl = char("Kylie", "High School Student")
define lun = char("Luna")
define nao = char("Naomi")
define sam = char("Sam")
define ste = char("Steve", "High School Graduate")

# BACKGROUNDS
image logo = "gui/logo.png"

# PARAMETERS
default dynamic_menu = "gui/game_menu.png"

# TRANSFORMS
transform choice_anim: 
    on hover: 
        linear 0.25 zoom 1.25 xalign 0.5
    on idle: 
        linear 0.25 zoom 1.0 xalign 0.5
transform shake:
    ease .05 xoffset 6
    ease .05 xoffset -6
    ease .05 xoffset 6
    ease .05 xoffset -6
    ease .05 xoffset 6
    ease .05 xoffset -6
transform vshake(new_widget, old_widget):
    delay 0.5
    contains:
        old_widget
        ease .05 yoffset 3
        ease .05 yoffset -3
        ease .05 yoffset 3
        ease .05 yoffset -3
        ease .05 yoffset 3
    contains:
        new_widget
        delay 0.25
        ease .05 yoffset -3
        ease .05 yoffset 3
        ease .05 yoffset -3
        ease .05 yoffset 3
        ease .05 yoffset 0
transform zoomshake(new_widget, old_widget):
    delay 0.5
    contains:
        old_widget
        truecenter
        linear .1 zoom 1.01 yalign 1.0
    contains:
        new_widget
        truecenter
        delay 0.1
        zoom 1.01 yalign 1.0
        linear .05 xoffset 6
        linear .05 xoffset -6
        linear .05 xoffset 6
        linear .05 xoffset -6
        linear .05 xoffset 6
        linear .05 xoffset -6
        linear .1 xoffset 0 zoom 1.0
transform zoomvshake(new_widget, old_widget):
    delay 0.5
    contains:
        old_widget
        truecenter
        linear .1 zoom 1.01 yalign 0.5
    contains:
        new_widget
        truecenter
        delay 0.1
        zoom 1.01 yalign 1.0
        linear .05 yoffset 6
        linear .05 yoffset -6
        linear .05 yoffset 6
        linear .05 yoffset -6
        linear .05 yoffset 6
        linear .05 yoffset -6
        linear .1 yoffset 0 zoom 1.0

# SPECIAL LABELS

label hide_interface:

if renpy.context()._menu:
    return
if _windows_hidden:
    return
python:
    _windows_hidden = True
    voice_sustain()
    renpy.hide_screen("say", "screens")
    renpy.hide_screen("choice", "screens")
    renpy.hide_screen("quick_menu", "quick_menu")
    ui.saybehavior(dismiss=['dismiss', 'hide_windows'])
    ui.interact(suppress_overlay=True, suppress_window=True)
    _windows_hidden = False

return

label game_over:
    
$ config.skipping = False
show black with fade
"End of [storypoint].{w} Please save your game now."
return

label start:

show screen quick_menu

# Disclaimer
show black
pause(0.5)
menu:
    "This game is not intended for minors. Are you of legal viewing age?"
    "Yes":
        call screen fetish_settings with dissolve
        if fetish_cheating == False:
            $ fetish_cuckolding = False
        if fetish_grotesque == False:
            $ fetish_futanari = False
        $ fetishes_chosen = True
        pause(0.5)
        jump prologue
    "No":
        return